%fonction pid1
function [R,S]=pid1(G,tm,D,Te)
% G : modle du syteme continu a asservir
% tm : temps de monte a obtenir
% D : depassement souhaite entre 0 et 1
% Te : periode d'echantillonnage
% retourne le correcteur C
% Modele
xi=-log(D)/sqrt(pi^2+(log(D))^2)
wn = 1/(tm*sqrt(1-xi*xi))*(pi-acos(xi))
Z1 = exp(-xi*wn*Te+j*sqrt(1-xi*xi)*wn*Te)
Hd = [1 -(Z1+Z1') Z1*Z1']
% Calcul transmittance bloquee
r =get(G,'InputDelay') % delay in sec.
d = r/Te
GBo = c2d(G,Te)
set(GBo,'variable','z^-1')
[B,A] = tfdata(GBo,'v')
% Ajout integrateur au systeme
AI = conv(A,[1 -1])% avec intgrateur
% Identite de Bezout
[R,S] = bezout(d,B,AI,Hd)
S = conv(S,[1 -1])
C = tf(R,S,Te,'variable','z^-1');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [R,S] = bezout(d,B,A,P)
% [R,S] = bezout(d,B,A,P)
% 
% Retourne les coefficients des polynomes R et S 
% correspondant a la relation de Bezout suivante :
%                       -d
%             P = AS + z  BR
%
a = length(A)-1;
B = [zeros(1,d) B];
b = length(B)-1;
s = b-1;
r = a-1;
p = length(P)-1;
M = zeros(a+b,a+b);
for k=1:s+1
	M(k:a+k,k) = A';
end;
for k=1:r+1
	M(k:b+k,k+s+1) = B';
end;
SR=M\[P zeros(1,a+b-length(P))]';
S = SR(1:s+1)';
R = SR(s+2:s+2+r)';
